
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class AccountsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const accounts = await db.accounts.create(
            {
                id: data.id || undefined,
        
        coding_mode: data.coding_mode
        ||
        null
            ,
            
        code: data.code
        ||
        null
            ,
            
        name: data.name
        ||
        null
            ,
            
        level: data.level
        ||
        null
            ,
            
        nature: data.nature
        ||
        null
            ,
            
        is_leaf: data.is_leaf
        ||
        false
        
            ,
            
        is_active: data.is_active
        ||
        false
        
            ,
            
        parent_code: data.parent_code
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await accounts.setBusiness( data.business || null, {
            transaction,
        });
        

        

        

        return accounts;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const accountsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                coding_mode: item.coding_mode
            ||
            null
            ,
            
                code: item.code
            ||
            null
            ,
            
                name: item.name
            ||
            null
            ,
            
                level: item.level
            ||
            null
            ,
            
                nature: item.nature
            ||
            null
            ,
            
                is_leaf: item.is_leaf
            ||
            false
        
            ,
            
                is_active: item.is_active
            ||
            false
        
            ,
            
                parent_code: item.parent_code
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const accounts = await db.accounts.bulkCreate(accountsData, { transaction });

        // For each item created, replace relation files
        

        return accounts;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        

        const accounts = await db.accounts.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.coding_mode !== undefined) updatePayload.coding_mode = data.coding_mode;
        
        
        if (data.code !== undefined) updatePayload.code = data.code;
        
        
        if (data.name !== undefined) updatePayload.name = data.name;
        
        
        if (data.level !== undefined) updatePayload.level = data.level;
        
        
        if (data.nature !== undefined) updatePayload.nature = data.nature;
        
        
        if (data.is_leaf !== undefined) updatePayload.is_leaf = data.is_leaf;
        
        
        if (data.is_active !== undefined) updatePayload.is_active = data.is_active;
        
        
        if (data.parent_code !== undefined) updatePayload.parent_code = data.parent_code;
        
        
        updatePayload.updatedById = currentUser.id;

        await accounts.update(updatePayload, {transaction});

        
        
        if (data.business !== undefined) {
            await accounts.setBusiness(
              
              data.business,
              
              { transaction }
            );
        }
        

        
        

        

        return accounts;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const accounts = await db.accounts.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of accounts) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of accounts) {
                await record.destroy({transaction});
            }
        });


        return accounts;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const accounts = await db.accounts.findByPk(id, options);

        await accounts.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await accounts.destroy({
            transaction
        });

        return accounts;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const accounts = await db.accounts.findOne(
            { where },
            { transaction },
        );

        if (!accounts) {
            return accounts;
        }

        const output = accounts.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.journal_lines_account = await accounts.getJournal_lines_account({
            transaction
        });
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.business = await accounts.getBusiness({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        

        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.businesses,
        as: 'business',
        
        where: filter.business ? {
          [Op.or]: [
            { id: { [Op.in]: filter.business.split('|').map(term => Utils.uuid(term)) } },
            {
              trade_name: {
                [Op.or]: filter.business.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.code) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'accounts',
                        'code',
                        filter.code,
                    ),
                };
            }
            
            if (filter.name) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'accounts',
                        'name',
                        filter.name,
                    ),
                };
            }
            
            if (filter.parent_code) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'accounts',
                        'parent_code',
                        filter.parent_code,
                    ),
                };
            }
            

            
            

            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.coding_mode) {
                where = {
                    ...where,
                coding_mode: filter.coding_mode,
            };
            }
            
            if (filter.level) {
                where = {
                    ...where,
                level: filter.level,
            };
            }
            
            if (filter.nature) {
                where = {
                    ...where,
                nature: filter.nature,
            };
            }
            
            if (filter.is_leaf) {
                where = {
                    ...where,
                is_leaf: filter.is_leaf,
            };
            }
            
            if (filter.is_active) {
                where = {
                    ...where,
                is_active: filter.is_active,
            };
            }
            


      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.accounts.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset, ) {
        let where = {};
        
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'accounts',
                        'name',
                        query,
                    ),
                ],
            };
        }

        const records = await db.accounts.findAll({
            attributes: [ 'id', 'name' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['name', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.name,
        }));
    }

    
};

